#include "globals.h"
#include <wx/url.h>

const int iUnitCount=5;
static wxString sUnit[iUnitCount]={_T("Octets"),_T("Ko"),_T("Mo"),_T("Go"),_T("To")};

wxString Size2Str(size_t size)
{
    double dRes=(double)size;
    wxString sRes=_T("");
    int i=0;
    while(i<iUnitCount-1)
    {
        if (dRes>1024.)
        {
            dRes/=1024;
            i++;
        } else {
            break;
        }
    }
    if (i)
        sRes.Printf(_T("%.2f %s"),dRes,sUnit[i].c_str());
    else
        sRes.Printf(_T("%d %s"),size,sUnit[0]);
    return sRes;
}

wxString LoadWebPage(const wxString& PageUrl,bool& bStopWanted)
{
    const int iBuffSize=256;
    char szBuff[iBuffSize+2];
    int iRead=0;
    bool bDoLoop=true;
    wxString sPage=_T("");
    wxURL *url=new wxURL(PageUrl);
    if (!url->IsOk())
    {
        delete url;
        sPage=_T("_LWP_ERROR_");
        return sPage;
    }
    wxInputStream *input=url->GetInputStream();
    wxString sTmp;
    if (input!=NULL)
    {
        // Connection Ok : on commence le tlchargement
        wxYield();
        while (bDoLoop)
        {
            // On tlcharge par blocs de 256 octets maxi
            input->Read(szBuff,iBuffSize);
            iRead=(int)input->LastRead();
            if (bStopWanted==true)
            {
                sPage=_T("_LWP_CANCELLED_");
                break;
            }
            wxYield(); // Pour ne pas bloquer la GUI
            if (iRead!=0) // A-t'on lu des donnes
            {
                // oui, alors on les stocke
                szBuff[iRead]=0;
                szBuff[iRead+1]=0;
                //sPage+=wxString(wxConvUTF8.cMB2WC(szBuff));
                //sPage+=wxConvLocal.cMB2WC(szBuff);
                sTmp=wxString(szBuff,wxConvUTF8);
                if (sTmp.IsEmpty())
                    sTmp=wxConvLocal.cMB2WC(szBuff);
                sPage+=sTmp;
            } else {
                // non, alors le tlchargement est termin
                bDoLoop=false;
                if (input->GetLastError()!=wxSTREAM_EOF)
                    sPage=_T("_LWP_ERROR_");
            }
            //for (iRead=0;iRead<iBuffSize;iRead++) szBuff[iRead]='\0';
        }
    } else {
        sPage=_T("_LWP_ERROR_");
    }
    if (input!=NULL) delete input;
    delete url;
    return sPage;
}
