#include "myprogressdlg.h"

BEGIN_EVENT_TABLE(MyProgressDlg,wxDialog)
    EVT_BUTTON(wxID_CANCEL,MyProgressDlg::OnCancel)
END_EVENT_TABLE()

MyProgressDlg::MyProgressDlg(wxWindow* parent,bool* bStopVar):wxDialog(parent,-1,_T("Recherche"),wxDefaultPosition,wxDefaultSize,wxCAPTION)
{
    prnt_wnd=parent;
    if (prnt_wnd!=NULL) prnt_wnd->Disable();
    wxBoxSizer* sizer1=new wxBoxSizer(wxVERTICAL);
        lblKeyWords=new wxStaticText(this,-1,_T("Recherche en cours sur www.radioblogclub.com de :"));
        sizer1->Add(lblKeyWords,0,wxALL|wxEXPAND,5);
        lblKeyWords=new wxStaticText(this,-1,_T(""),wxDefaultPosition,wxDefaultSize,wxALIGN_CENTRE|wxST_NO_AUTORESIZE);
        sizer1->Add(lblKeyWords,0,wxLEFT|wxRIGHT|wxEXPAND,5);
        prgbar=new wxGauge(this,-1,100,wxDefaultPosition,wxSize(-1,20));
        sizer1->Add(prgbar,0,wxALL|wxEXPAND,5);
        sizer1->AddSpacer(1);
        sizer1->Add(new wxButton(this,wxID_CANCEL,_T("Annuler")),0,wxALL|wxALIGN_CENTER,5);
    SetSizer(sizer1);
    sizer1->SetSizeHints(this);
    CenterOnParent();
    Show();
    m_ID_Timer=wxNewId();
    timer=new wxTimer(this,m_ID_Timer);
    Connect(m_ID_Timer,wxEVT_TIMER,wxTimerEventHandler(MyProgressDlg::OnTimer));
    bCancel=false;
    pbStop=bStopVar;
}

MyProgressDlg::~MyProgressDlg()
{
    if (prnt_wnd!=NULL) prnt_wnd->Enable();
    delete timer;
}

void MyProgressDlg::OnCancel(wxCommandEvent& event)
{
    Show(false);
    bCancel=true;
    if (pbStop!=NULL) *pbStop=true;
}

void MyProgressDlg::SetKeywords(const wxString& keywords)
{
    lblKeyWords->SetLabel(keywords);
    GetSizer()->SetSizeHints(this);
}

void MyProgressDlg::Pulse()
{
    prgbar->Pulse();
    Refresh();
}

void MyProgressDlg::StartAutoPulse()
{
    if (!timer->IsRunning()) timer->Start(50,false);
}

void MyProgressDlg::StopAutoPulse()
{
    if (timer->IsRunning()) timer->Stop();
}

void MyProgressDlg::OnTimer(wxTimerEvent& event)
{
    prgbar->Pulse();
}

bool MyProgressDlg::IsCancelled()
{
    return bCancel;
}

bool MyProgressDlg::Show(bool show)
{
    if ((!show)&&(prnt_wnd!=NULL)) prnt_wnd->Enable();
    return wxDialog::Show(show);
}
