#include "playerpanel.h"
#include "wxfmodplayer.h"
#include "res/playlist_buttons.xpm"

#include "RB_SongList.h"
#include "globals.h"
#include <wx/filedlg.h>
#include <wx/wfstream.h>

int ID_MediaCtrl=wxNewId();
int ID_LstPlayList=wxNewId();
int ID_BtnUp=wxNewId();
int ID_BtnDown=wxNewId();
int ID_BtnTop=wxNewId();
int ID_BtnBottom=wxNewId();

BEGIN_EVENT_TABLE(PlayerPanel,wxPanel)
    EVT_LIST_ITEM_ACTIVATED(ID_LstPlayList,PlayerPanel::OnListItemActivated)
    EVT_LIST_ITEM_SELECTED(ID_LstPlayList,PlayerPanel::OnListItemSelected)
    EVT_LIST_ITEM_DESELECTED(ID_LstPlayList,PlayerPanel::OnListItemDeselected)
    EVT_LIST_END_LABEL_EDIT(ID_LstPlayList,PlayerPanel::OnEndLabelEdit)
    EVT_FMP_FINISHED(ID_MediaCtrl,PlayerPanel::OnPlayerFinished)
    EVT_FMP_NEXTFILE(ID_MediaCtrl,PlayerPanel::OnNextPressed)
    EVT_FMP_PREVFILE(ID_MediaCtrl,PlayerPanel::OnPrevPressed)
#ifdef ENABLE_SAVE_BUTTON
    EVT_BUTTON(wxID_SAVE,PlayerPanel::OnBtnSaveClicked)
#endif // ENABLE_SAVE_BUTTON
    EVT_BUTTON(ID_BtnTop,PlayerPanel::OnBtnTopClicked)
    EVT_BUTTON(ID_BtnUp,PlayerPanel::OnBtnUpClicked)
    EVT_BUTTON(ID_BtnDown,PlayerPanel::OnBtnDownClicked)
    EVT_BUTTON(ID_BtnBottom,PlayerPanel::OnBtnBottomClicked)
    EVT_BUTTON(wxID_PROPERTIES,PlayerPanel::OnBtnInfosClicked)
    EVT_BUTTON(wxID_DELETE,PlayerPanel::OnBtnDeleteClicked)
    EVT_BUTTON(wxID_ABOUT,PlayerPanel::OnBtnAboutClicked)
END_EVENT_TABLE()

PlayerPanel::PlayerPanel(wxWindow* parent):PagePanel(parent,_T("Lecture"))
{
    wxBoxSizer* basesizer=new wxBoxSizer(wxVERTICAL);
        mediactrl=new wxFModPlayer(this,ID_MediaCtrl);
        mediactrl->EnableButtons(FMP_BUTTON_NONE);
    basesizer->Add(mediactrl,0,wxLEFT|wxRIGHT|wxTOP|wxEXPAND,5);
    wxBoxSizer* bottomsizer=new wxBoxSizer(wxHORIZONTAL);
            wxStaticBoxSizer* sizer1=new wxStaticBoxSizer(wxVERTICAL,this,_T("PlayList :"));
                lstPlayList=new wxListCtrl(this,ID_LstPlayList,wxDefaultPosition,wxDefaultSize,wxLC_NO_HEADER|wxLC_REPORT|wxLC_EDIT_LABELS|wxLC_SINGLE_SEL);
                lstPlayList->InsertColumn(0,_T("FileName"));
                lstPlayList->SetColumnWidth(0,wxLIST_AUTOSIZE);
                sizer1->Add(lstPlayList,1,wxALL|wxEXPAND,5);
            bottomsizer->Add(sizer1,1,wxALL|wxEXPAND,5);
            wxStaticBoxSizer* sizer2=new wxStaticBoxSizer(wxVERTICAL,this,_T("Gestion Playlist :"));
                wxBoxSizer* szr21=new wxBoxSizer(wxHORIZONTAL);
                //btnTop=new wxButton(this,ID_BtnTop,_T("Top"));
                //sizer2->Add(btnTop,0,wxLEFT|wxRIGHT|wxTOP,5);
                    btnTop=new wxBitmapButton(this,ID_BtnTop,button_top_enabled_xpm);
                    btnTop->SetBitmapDisabled(button_top_disabled_xpm);
                    btnTop->SetBitmapHover(button_top_hover_xpm);
                    btnTop->SetToolTip(_T("D\351placer au sommet de la liste"));
                    szr21->Add(btnTop,0,wxRIGHT|wxEXPAND,5);
                //btnUp=new wxButton(this,ID_BtnUp,_T("Up"));
                //sizer2->Add(btnUp,0,wxLEFT|wxRIGHT|wxTOP,5);
                    btnUp=new wxBitmapButton(this,ID_BtnUp,button_up_enabled_xpm);
                    btnUp->SetBitmapDisabled(button_up_disabled_xpm);
                    btnUp->SetBitmapHover(button_up_hover_xpm);
                    btnUp->SetToolTip(_T("D\351placer d'un cran vers le haut"));
                    szr21->Add(btnUp,0,wxLEFT|wxEXPAND,5);
                sizer2->Add(szr21,0,wxLEFT|wxRIGHT|wxTOP,5);
                wxBoxSizer* szr22=new wxBoxSizer(wxHORIZONTAL);
                //btnDown=new wxButton(this,ID_BtnDown,_T("Down"));
                //sizer2->Add(btnDown,0,wxLEFT|wxRIGHT|wxTOP,5);
                    btnBottom=new wxBitmapButton(this,ID_BtnBottom,button_bottom_enabled_xpm);
                    btnBottom->SetBitmapDisabled(button_bottom_disabled_xpm);
                    btnBottom->SetBitmapHover(button_bottom_hover_xpm);
                    btnBottom->SetToolTip(_T("D\351placer au fond de la liste"));
                    szr22->Add(btnBottom,0,wxRIGHT|wxEXPAND,5);
                //btnBottom=new wxButton(this,ID_BtnBottom,_T("Bottom"));
                //sizer2->Add(btnBottom,0,wxLEFT|wxRIGHT|wxTOP,5);
                    btnDown=new wxBitmapButton(this,ID_BtnDown,button_down_enabled_xpm);
                    btnDown->SetBitmapDisabled(button_down_disabled_xpm);
                    btnDown->SetBitmapHover(button_down_hover_xpm);
                    btnDown->SetToolTip(_T("D\351placer d'un cran vers le bas"));
                    szr22->Add(btnDown,0,wxLEFT|wxEXPAND,5);
                sizer2->Add(szr22,0,wxLEFT|wxRIGHT|wxTOP,5);
                btnInfos=new wxButton(this,wxID_PROPERTIES,_T("Infos"));
                sizer2->Add(btnInfos,0,wxLEFT|wxRIGHT|wxTOP,5);
                btnDel=new wxButton(this,wxID_DELETE,_T("Effacer"));
                sizer2->Add(btnDel,0,wxLEFT|wxRIGHT|wxTOP,5);
#ifdef ENABLE_SAVE_BUTTON
                btnSave=new wxButton(this,wxID_SAVE,_T("Enregistrer"));
                sizer2->Add(btnSave,0,wxLEFT|wxRIGHT|wxTOP,5);
#endif // ENABLE_SAVE_BUTTON
                btnAbout=new wxButton(this,wxID_ABOUT,_T("A propos..."));
                sizer2->Add(btnAbout,0,wxLEFT|wxRIGHT|wxTOP,5);
            bottomsizer->Add(sizer2,0,wxRIGHT|wxTOP|wxBOTTOM|wxEXPAND,5);
    basesizer->Add(bottomsizer,1,wxALL|wxEXPAND,0);

    SetSizer(basesizer);
    iCurrent=-1;
    mediactrl->Initialize();
    CheckPlayListButtons();
}

PlayerPanel::~PlayerPanel()
{
    //dtor
}

void PlayerPanel::UpdatePlayList()
{
    long l;
    RB_Song* cursong;
    wxRB_SongListNode* node=MySongList.GetFirst();
    while(node!=NULL)
    {
        // On vrifie toutes les entres dans la wxList
        cursong=node->GetData();
        if (cursong->State==2)
        {
            // On regarde si l'entre courante est dans le wxListCtrl
            l=lstPlayList->FindItem(-1,(long)cursong);
            if (l==-1) // Si elle n'y est pas, alors on l'ajoute
            {
                l=lstPlayList->InsertItem(lstPlayList->GetItemCount(),cursong->Name);
                lstPlayList->SetItemData(l,(long)cursong);
                // S'il s'agit du premier lment ajout dans la PlayList,
                // Alors on le charge dans le player
                if (lstPlayList->GetItemCount()==1)
                {
                    mediactrl->SetStreamDatas(cursong->Datas.GetData(),cursong->Datas.GetBufSize(),cursong->Name);
                    iCurrent=0;
                }
            }
        }
        node=node->GetNext();
    }
    int iCount=lstPlayList->GetItemCount();
    int ibtnplay=(iCount>0)?FMP_BUTTON_PLAY:0;
    int ibtnstop=((mediactrl->IsPlaying())||(mediactrl->IsPaused()))?FMP_BUTTON_STOP:0;
    int ibtnprnx=(iCount>1)?FMP_BUTTON_NEXT|FMP_BUTTON_PREV:0;
    mediactrl->EnableButtons(ibtnplay|ibtnstop|ibtnprnx);
    CheckPlayListButtons();
    UpdatePlayListItemsState();
}

void PlayerPanel::CheckPlayListButtons()
{
    int i,icount=lstPlayList->GetItemCount();
    bool b1=false,b2=false,b3=false;
    if ((icount>0)&&(lstPlayList->GetSelectedItemCount()!=0))
    {
        if (icount==1)
        {
            b3=true;
        } else {
            for (i=0;i<icount;i++)
            {
                if (lstPlayList->GetItemState(i,wxLIST_STATE_SELECTED)==wxLIST_STATE_SELECTED)
                {
                    b3=true;
                    if (i==0)
                    {
                        b1=false;
                        b2=true;
                    } else {
                        if (i==(icount-1))
                        {
                            b1=true;
                            b2=false;
                        } else {
                            b1=true;
                            b2=true;
                        }
                    }
                }
            }
        }
    }
    btnTop->Enable(b1);
    btnUp->Enable(b1);
    btnDown->Enable(b2);
    btnBottom->Enable(b2);
    btnInfos->Enable(b3);
    btnDel->Enable(b3);
#ifdef ENABLE_SAVE_BUTTON
    btnSave->Enable(b3);
#endif // ENABLE_SAVE_BUTTON
}

void PlayerPanel::UpdatePlayListItemsState()
{
    // Changer la police de caractres du wxListItem pour le diffrencier des autres
    wxFont fnt;
    int i;
    for (i=0;i<lstPlayList->GetItemCount();i++)
    {
        fnt=lstPlayList->GetItemFont(i);
        if (i==iCurrent)
        {
            fnt.SetStyle(wxFONTSTYLE_ITALIC);
            fnt.SetWeight(wxFONTWEIGHT_BOLD);
            lstPlayList->SetItemTextColour(i,*wxBLUE);
        } else {
            fnt.SetStyle(wxFONTSTYLE_NORMAL);
            fnt.SetWeight(wxFONTWEIGHT_NORMAL);
            lstPlayList->SetItemTextColour(i,*wxBLACK);
        }
        lstPlayList->SetItemFont(i,fnt);
    }
    // Mettre  jour la largeur de la colonne, pour que tout soit visible
    lstPlayList->SetColumnWidth(0,wxLIST_AUTOSIZE);
}

void PlayerPanel::OnListItemActivated(wxListEvent& event)
{
    // Double-click sur un item permet sa lecture directe
    int idx=event.GetIndex();
    if (idx==iCurrent) return;
    iCurrent=idx;
    //mediactrl->StopPlaying();
    RB_Song* cursong=(RB_Song*)lstPlayList->GetItemData((long)iCurrent);
    mediactrl->SetStreamDatas(cursong->Datas.GetData(),cursong->Datas.GetBufSize(),cursong->Name);
    mediactrl->StartPlaying();
    UpdatePlayListItemsState();
}
void PlayerPanel::OnListItemSelected(wxListEvent& event)
{
    CheckPlayListButtons();
}
void PlayerPanel::OnListItemDeselected(wxListEvent& event)
{
    CheckPlayListButtons();
}

void PlayerPanel::OnPlayerFinished(wxCommandEvent &event)
{
    // S'il n'y a rien dans la PlayList, on n'a rien  faire ici
    int iCount=lstPlayList->GetItemCount();
    if (iCount==0) return;
    // S'il y a plusieurs lments dans la PlayList, alors on slectionne le suivant
    if (iCount>1)
    {
        iCurrent++;
        // Si on a dpass le dernier, alors on recommence au dbut
        if (iCurrent==iCount) iCurrent=0;
        RB_Song* cursong=(RB_Song*)lstPlayList->GetItemData((long)iCurrent);
        mediactrl->SetStreamDatas(cursong->Datas.GetData(),cursong->Datas.GetBufSize(),cursong->Name);
    }
    // On redmarre le lecteur
    mediactrl->StartPlaying(true);
    // On mets  jour les lments de la PlayList
    UpdatePlayListItemsState();
}

void PlayerPanel::OnNextPressed(wxCommandEvent &event)
{
    // Si la liste est vide, ou qu'il n'y a qu'un seul lmnt, alors on se tire de l...
    int iCount=lstPlayList->GetItemCount();
    if (iCount<=1) return;
    // On regarde si le player tait en train de jouer
    bool bplay=mediactrl->IsPlaying();
    // Sinon, on passe  l'lment suivant
    iCurrent++;
    // Si on a dpass le dernier, alors on recommence au dbut
    if (iCurrent==iCount) iCurrent=0;
    RB_Song* cursong=(RB_Song*)lstPlayList->GetItemData((long)iCurrent);
    mediactrl->SetStreamDatas(cursong->Datas.GetData(),cursong->Datas.GetBufSize(),cursong->Name);
    // On redmarre le lecteur s'il tait en route
    if (bplay) mediactrl->StartPlaying(true);
    // On mets  jour les lments de la PlayList
    lstPlayList->SetItemState(iCurrent,wxLIST_STATE_SELECTED|wxLIST_STATE_FOCUSED,wxLIST_STATE_SELECTED|wxLIST_STATE_FOCUSED);
    UpdatePlayListItemsState();
    lstPlayList->SetFocus();
    CheckPlayListButtons();
}

void PlayerPanel::OnPrevPressed(wxCommandEvent &event)
{
    // Si la liste est vide, ou qu'il n'y a qu'un seul lmnt, alors on se tire de l...
    int iCount=lstPlayList->GetItemCount();
    if (iCount<=1) return;
    // On regarde si le player tait en train de jouer
    bool bplay=mediactrl->IsPlaying();
    // Sinon, on passe  l'lment prcdent
    iCurrent--;
    // Si on a dpass le premier, alors on recommence  la fin
    if (iCurrent<0) iCurrent=iCount-1;
    RB_Song* cursong=(RB_Song*)lstPlayList->GetItemData((long)iCurrent);
    mediactrl->SetStreamDatas(cursong->Datas.GetData(),cursong->Datas.GetBufSize(),cursong->Name);
    // On redmarre le lecteur s'il tait en route
    if (bplay) mediactrl->StartPlaying(true);
    // On mets  jour les lments de la PlayList
    lstPlayList->SetItemState(iCurrent,wxLIST_STATE_SELECTED|wxLIST_STATE_FOCUSED,wxLIST_STATE_SELECTED|wxLIST_STATE_FOCUSED);
    UpdatePlayListItemsState();
    lstPlayList->SetFocus();
    CheckPlayListButtons();
}

void PlayerPanel::OnEndLabelEdit(wxListEvent& event)
{
    wxString newLabel=event.GetLabel();
    int idx=(int)event.GetIndex();
    RB_Song* currsong=(RB_Song*)lstPlayList->GetItemData((long)idx);
    if (newLabel.Lower()==_T("save"))
    {
        wxFileDialog fdlg(this,_T("Enregistrement au format mp3"),_T(""),lstPlayList->GetItemText(idx),_T("Fichiers mp3|*.mp3"),wxSAVE|wxOVERWRITE_PROMPT);
        if (fdlg.ShowModal()==wxID_OK)
        {
            wxFileOutputStream f_out(fdlg.GetPath());
            if (f_out.Ok())
            {
                f_out.Write(currsong->Datas.GetData(),currsong->Datas.GetBufSize());
            } else {
                wxMessageBox(_T("Erreur lors de la cr\351ation du fichier..."),_T("Erreur"),wxICON_EXCLAMATION);
            }
        }
        event.Veto();
        return;
    }
    if (idx==iCurrent) mediactrl->SetDisplayName(event.GetLabel());
    currsong->Name=event.GetLabel();
}

void PlayerPanel::OnBtnTopClicked(wxCommandEvent &event)
{
    // Rcuprer l'index de l'item slectionn
    int iIdx=lstPlayList->GetNextItem(-1,wxLIST_NEXT_ALL,wxLIST_STATE_SELECTED);
    if (iIdx==-1) return;
    // Rcuprer l'adresse de l'entre associe en mmoire
    RB_Song* currsong=(RB_Song*)lstPlayList->GetItemData(iIdx);
    // Supprimer l'entre courante du wxListCtrl
    lstPlayList->DeleteItem(iIdx);
    // Re-rer l'entre au dbut de la liste
    lstPlayList->InsertItem(0,currsong->Name);
    lstPlayList->SetItemData(0,(long)currsong);
    // Si on a dplac l'entre en cours de lecture, alors on r-ajuste les variables
    if (iCurrent==iIdx)
        iCurrent=0;
    else
        iCurrent+=(iCurrent<iIdx)?1:0;
    // On re-slectionne cet lment
    lstPlayList->SetItemState(0,wxLIST_STATE_SELECTED|wxLIST_STATE_FOCUSED,wxLIST_STATE_SELECTED|wxLIST_STATE_FOCUSED);
    // On mets  jour la liste et les boutons
    UpdatePlayListItemsState();
    CheckPlayListButtons();
    lstPlayList->SetFocus();
}

void PlayerPanel::OnBtnBottomClicked(wxCommandEvent &event)
{
    // Rcuprer l'index de l'item slectionn
    int iIdx=lstPlayList->GetNextItem(-1,wxLIST_NEXT_ALL,wxLIST_STATE_SELECTED);
    if (iIdx==-1) return;
    // Rcuprer l'adresse de l'entre associe en mmoire
    RB_Song* currsong=(RB_Song*)lstPlayList->GetItemData(iIdx);
    // Supprimer l'entre courante du wxListCtrl
    lstPlayList->DeleteItem(iIdx);
    // Re-rer l'entre  la fin de la liste
    long l=lstPlayList->InsertItem(lstPlayList->GetItemCount(),currsong->Name);
    lstPlayList->SetItemData(l,(long)currsong);
    // Si on a dplac l'entre en cours de lecture, alors on r-ajuste les variables
    if (iCurrent==iIdx)
        iCurrent=l;
    else
        iCurrent-=(iCurrent>iIdx)?1:0;
    // On re-slectionne cet lment
    lstPlayList->SetItemState(l,wxLIST_STATE_SELECTED|wxLIST_STATE_FOCUSED,wxLIST_STATE_SELECTED|wxLIST_STATE_FOCUSED);
    // On mets  jour la liste et les boutons
    UpdatePlayListItemsState();
    CheckPlayListButtons();
    lstPlayList->SetFocus();
}

void PlayerPanel::OnBtnUpClicked(wxCommandEvent &event)
{
    // Rcuprer l'index de l'item slectionn
    int iIdx=lstPlayList->GetNextItem(-1,wxLIST_NEXT_ALL,wxLIST_STATE_SELECTED);
    if (iIdx==-1) return;
    // Rcuprer l'adresse de l'entre associe en mmoire
    RB_Song* currsong=(RB_Song*)lstPlayList->GetItemData(iIdx);
    // Supprimer l'entre courante du wxListCtrl
    lstPlayList->DeleteItem(iIdx);
    // Re-rer l'entre avant l'entre prcdente
    long l=lstPlayList->InsertItem(iIdx-1,currsong->Name);
    lstPlayList->SetItemData(l,(long)currsong);
    // Si on a dplac l'entre en cours de lecture, alors on r-ajuste les variables
    if (iCurrent==iIdx)
        iCurrent--;
    else
        iCurrent+=(iCurrent==(iIdx-1))?1:0;
    // On re-slectionne cet lment
    lstPlayList->SetItemState(l,wxLIST_STATE_SELECTED|wxLIST_STATE_FOCUSED,wxLIST_STATE_SELECTED|wxLIST_STATE_FOCUSED);
    // On mets  jour la liste et les boutons
    UpdatePlayListItemsState();
    CheckPlayListButtons();
    lstPlayList->SetFocus();
}

void PlayerPanel::OnBtnDownClicked(wxCommandEvent &event)
{
    // Rcuprer l'index de l'item slectionn
    int iIdx=lstPlayList->GetNextItem(-1,wxLIST_NEXT_ALL,wxLIST_STATE_SELECTED);
    if (iIdx==-1) return;
    // Rcuprer l'adresse de l'entre associe en mmoire
    RB_Song* currsong=(RB_Song*)lstPlayList->GetItemData(iIdx);
    // Supprimer l'entre courante du wxListCtrl
    lstPlayList->DeleteItem(iIdx);
    // Re-rer l'entre aprs l'entre suivante
    long l=lstPlayList->InsertItem(iIdx+1,currsong->Name);
    lstPlayList->SetItemData(l,(long)currsong);
    // Si on a dplac l'entre en cours de lecture, alors on r-ajuste les variables
    if (iCurrent==iIdx)
        iCurrent++;
    else
        iCurrent-=(iCurrent==(iIdx+1))?1:0;
    // On re-slectionne cet lment
    lstPlayList->SetItemState(l,wxLIST_STATE_SELECTED|wxLIST_STATE_FOCUSED,wxLIST_STATE_SELECTED|wxLIST_STATE_FOCUSED);
    // On mets  jour la liste et les boutons
    UpdatePlayListItemsState();
    CheckPlayListButtons();
    lstPlayList->SetFocus();
}

void PlayerPanel::OnBtnInfosClicked(wxCommandEvent &event)
{
    // Rcuprer l'index de l'item slectionn
    int iIdx=lstPlayList->GetNextItem(-1,wxLIST_NEXT_ALL,wxLIST_STATE_SELECTED);
    if (iIdx==-1) return;
    // Rcuprer l'adresse de l'entre associe en mmoire
    RB_Song* currsong=(RB_Song*)lstPlayList->GetItemData(iIdx);

    wxString sMsg=_T(""),sTmp;
    sMsg.Printf(_T("Fichier : %s"),currsong->Name.c_str());
    int i=currsong->Url.Find(_T('/'),true);
    sTmp=currsong->Url.Left(i);
    sMsg.Append(wxString::Format(_T("\nUrl : %s"),sTmp.c_str()));
    sTmp=Size2Str(currsong->Datas.GetBufSize());
    sMsg.Append(wxString::Format(_T("\nTaille : %s (%d octets)"),sTmp.c_str(),currsong->Datas.GetBufSize()));
    wxMessageBox(sMsg,_T("Infos fichiers"));
}

void PlayerPanel::OnBtnDeleteClicked(wxCommandEvent &event)
{
    // Rcuprer l'index de l'item slectionn
    int iIdx=lstPlayList->GetNextItem(-1,wxLIST_NEXT_ALL,wxLIST_STATE_SELECTED);
    if (iIdx==-1) return;
    // Rcuprer l'entre associe en mmoire
    RB_Song* currsong=(RB_Song*)lstPlayList->GetItemData(iIdx);
    // Demander confirmation
    if (wxMessageBox(_T("Supprimer \"") + currsong->Name + _T("\" de la playlist ?"),_T("Confirmation"),wxICON_QUESTION|wxYES_NO)==wxNO) return;
    if (lstPlayList->GetItemCount()==1)
    {
        // S'il n'y a qu'un entre dans la playlist et qu'on veut la supprimer
        // Alors, il faut arrter le player
        mediactrl->StopPlaying();
        mediactrl->SetStreamDatas(NULL,0,_T(""));
        iCurrent=-1;
    } else {
        if (iCurrent==iIdx)
        {
            // Sinon, si on veut supprimer l'entre en cours de lecture,
            // Il faut d'abord passer au morceau suivant
            wxCommandEvent evt;
            OnNextPressed(evt);
        }
    }
    // On supprime l'entre dans le wxListCtrl
    lstPlayList->DeleteItem(iIdx);
    // On supprime l'entre dans la liste en mmoire
    MySongList.DeleteObject(currsong);
    // Et on supprime l'objet lui-mme
    delete currsong;
    // On r-ajuste ventuellement le numro de l'lment en cours de lecture
    if (iCurrent>iIdx) iCurrent--;
    // On met  jour la GUI
    UpdatePlayListItemsState();
    CheckPlayListButtons();
}

#ifdef ENABLE_SAVE_BUTTON
void PlayerPanel::OnBtnSaveClicked(wxCommandEvent& event)
{
    // Rcuprer l'index de l'item slectionn
    int iIdx=lstPlayList->GetNextItem(-1,wxLIST_NEXT_ALL,wxLIST_STATE_SELECTED);
    if (iIdx==-1) return;
    // Rcuprer l'entre associe en mmoire
    RB_Song* currsong=(RB_Song*)lstPlayList->GetItemData(iIdx);
    // Afficher la boite de dialogue d'enregistrement
    wxFileDialog fdlg(this,_T("Enregistrement au format mp3"),_T(""),lstPlayList->GetItemText(iIdx),_T("Fichiers mp3|*.mp3"),wxSAVE|wxOVERWRITE_PROMPT);
    if (fdlg.ShowModal()==wxID_OK)
    {
        wxFileOutputStream f_out(fdlg.GetPath());
        if (f_out.Ok())
        {
            f_out.Write(currsong->Datas.GetData(),currsong->Datas.GetBufSize());
        } else {
            wxMessageBox(_T("Erreur lors de la cr\351ation du fichier..."),_T("Erreur"),wxICON_EXCLAMATION);
        }
    }
}
#endif // ENABLE_SAVE_BUTTON

#include "aboutdlg.h"
void PlayerPanel::OnBtnAboutClicked(wxCommandEvent &event)
{
    AboutDlg dlg(GetGrandParent());
    dlg.ShowModal();
}
