#ifndef PLAYERPANEL_H_INCLUDED
#define PLAYERPANEL_H_INCLUDED

#define ENABLE_SAVE_BUTTON

#include "pagepanel.h"
#include <wx/listctrl.h>
class wxFModPlayer;

class PlayerPanel : public PagePanel
{
public:
    PlayerPanel(wxWindow* parent);
    virtual ~PlayerPanel();
    void UpdatePlayList();
protected:
private:
    int iCurrent;
    wxFModPlayer* mediactrl;
    wxListCtrl* lstPlayList;
    wxBitmapButton *btnTop,*btnUp,*btnDown,*btnBottom;
    wxButton *btnDel,*btnInfos,*btnAbout;
#ifdef ENABLE_SAVE_BUTTON
    wxButton *btnSave;
    void OnBtnSaveClicked(wxCommandEvent& event);
#endif // ENABLE_SAVE_BUTTON
    void OnBtnTopClicked(wxCommandEvent& event);
    void OnBtnUpClicked(wxCommandEvent& event);
    void OnBtnDownClicked(wxCommandEvent& event);
    void OnBtnBottomClicked(wxCommandEvent& event);
    void OnBtnInfosClicked(wxCommandEvent& event);
    void OnBtnDeleteClicked(wxCommandEvent& event);
    void OnBtnAboutClicked(wxCommandEvent& event);
    void CheckPlayListButtons();
    void UpdatePlayListItemsState();
    void OnListItemActivated(wxListEvent& event);
    void OnListItemSelected(wxListEvent& event);
    void OnListItemDeselected(wxListEvent& event);
    void OnEndLabelEdit(wxListEvent& event);
    void OnPlayerFinished(wxCommandEvent& event);
    void OnNextPressed(wxCommandEvent& event);
    void OnPrevPressed(wxCommandEvent& event);
    DECLARE_EVENT_TABLE();
};
#endif
