#ifndef RBLOADER_H_INCLUDED
#define RBLOADER_H_INCLUDED

#include <wx/wxprec.h>
#ifndef WX_PRECOMP
 #include <wx/wx.h>
#endif

#include "loaderthread.h"
#include "RB_SongList.h"

class RBLoader : public wxPanel
{
public:
    RBLoader(wxWindow* parent,wxWindowID id,const wxString& title=_T("RadioBlog Sound Loader : "));
    virtual ~RBLoader();
    bool IsWorking();
    bool SetCurrentJob(RB_Song* entry);
    RB_Song* GetCurrentJobPtr();
protected:
private:
    LoaderThread* ldrthrd;
    RB_Song* currsong;
    wxStaticBox* stbMain;
    wxStaticText* lblCurFile, *lblInfos;
    wxButton *btnCancel;
    wxGauge* pgbLdState;
    wxTimer* animtimer;
    void OnTimer(wxTimerEvent& event);
    void OnCancelButtonClicked(wxCommandEvent& event);
    void OnThreadEnded(wxCommandEvent& event);
    void OnThreadError(wxCommandEvent& event);
    void OnThreadCancelled(wxCommandEvent& event);
    void OnThreadStateChanged(wxCommandEvent& event);
    DECLARE_EVENT_TABLE();
};

#endif // RBLOADER_H_INCLUDED
