#include "wxfmodplayer.h"
#include "res/player_buttons.xpm"

#ifdef _MSC_VER
    #pragma comment(lib,"fmodex_vc.lib")
#endif

#define TIMER_INTEVALL 125

int ID_SldPos=wxNewId();
int ID_SldVol=wxNewId();
int ID_BtnPlay=wxNewId();
int ID_BtnStop=wxNewId();
int ID_BtnPrev=wxNewId();
int ID_BtnNext=wxNewId();

const wxEventType wxEVT_FMP_NEXTFILE = wxNewEventType();
const wxEventType wxEVT_FMP_PREVFILE = wxNewEventType();
const wxEventType wxEVT_FMP_FINISHED = wxNewEventType();

BEGIN_EVENT_TABLE(wxFModPlayer,wxPanel)
    EVT_BUTTON(ID_BtnPlay,wxFModPlayer::OnBtnPlayClicked)
    EVT_BUTTON(ID_BtnStop,wxFModPlayer::OnBtnStopClicked)
    EVT_BUTTON(ID_BtnPrev,wxFModPlayer::OnBtnPrevClicked)
    EVT_BUTTON(ID_BtnNext,wxFModPlayer::OnBtnNextClicked)
    EVT_COMMAND_SCROLL(ID_SldVol,wxFModPlayer::OnChangeVolume)
    EVT_COMMAND_SCROLL(ID_SldPos,wxFModPlayer::OnChangePosition)
END_EVENT_TABLE()

wxFModPlayer::wxFModPlayer(wxWindow* parent,wxWindowID id) : wxPanel(parent,id)
{
    wxStaticText* label;
    wxStaticBoxSizer* mainsizer=new wxStaticBoxSizer(wxHORIZONTAL,this,_T("Sound player : "));
    stbMain=mainsizer->GetStaticBox();
        wxBoxSizer* leftsizer=new wxBoxSizer(wxVERTICAL);
            sttStrmInfo=new wxStaticText(this,-1,_T("- - -"));
            leftsizer->Add(sttStrmInfo,0,wxLEFT|wxRIGHT|wxEXPAND,5);
            sldProgress=new wxSlider(this,ID_SldPos,0,0,1000,wxDefaultPosition,wxDefaultSize,wxSL_HORIZONTAL);
            sldProgress->Enable(false);
            leftsizer->Add(sldProgress,0,wxALL|wxEXPAND,0);
            wxBoxSizer* btnsizer=new wxBoxSizer(wxHORIZONTAL);
                btnPlay=new wxBitmapButton(this,ID_BtnPlay,play_e_xpm);
                btnPlay->SetBitmapDisabled(play_d_xpm);
                btnPlay->SetBitmapHover(play_h_xpm);
                btnPlay->SetToolTip(_T("Mettre en route le lecteur"));
                btnsizer->Add(btnPlay,0,wxLEFT|wxRIGHT,5);
                btnStop=new wxBitmapButton(this,ID_BtnStop,stop_e_xpm);
                btnStop->SetBitmapDisabled(stop_d_xpm);
                btnStop->SetBitmapHover(stop_h_xpm);
                btnStop->SetToolTip(_T("Arr\352ter le lecteur"));
                btnsizer->Add(btnStop,0,wxALL,0);
                btnPrev=new wxBitmapButton(this,ID_BtnPrev,prev_e_xpm);
                btnPrev->SetBitmapDisabled(prev_d_xpm);
                btnPrev->SetBitmapHover(prev_h_xpm);
                btnPrev->SetToolTip(_T("Passer au morceau pr\351c\351dent"));
                btnsizer->Add(btnPrev,0,wxLEFT|wxRIGHT,5);
                btnNext=new wxBitmapButton(this,ID_BtnNext,next_e_xpm);
                btnNext->SetBitmapDisabled(next_d_xpm);
                btnNext->SetBitmapHover(next_h_xpm);
                btnNext->SetToolTip(_T("Passer au morceau suivant"));
                btnsizer->Add(btnNext,0,wxRIGHT,5);
                sttPlayInfo=new wxStaticText(this,-1,_T("Position : 00:00 / 00:00"),wxDefaultPosition,wxDefaultSize,wxST_NO_AUTORESIZE);
                btnsizer->Add(sttPlayInfo,1,wxALL|wxALIGN_CENTER_VERTICAL,5);
            leftsizer->Add(btnsizer,0,wxALL|wxEXPAND,0);
        mainsizer->Add(leftsizer,1,wxALL|wxEXPAND,0);
            wxBoxSizer* rightsizer=new wxBoxSizer(wxVERTICAL);
                label=new wxStaticText(this,-1,_T("Volume"),wxDefaultPosition,wxDefaultSize,wxALIGN_CENTRE|wxST_NO_AUTORESIZE);
                rightsizer->Add(label,0,wxALL|wxEXPAND,0);
                sldVolume=new wxSlider(this,ID_SldVol,127,0,255,wxDefaultPosition,wxSize(75,-1),wxSL_HORIZONTAL);
                sldVolume->Enable(false);
                rightsizer->Add(sldVolume,0,wxALL|wxEXPAND,0);
                wxBoxSizer* sizer2=new wxBoxSizer(wxHORIZONTAL);
                    label=new wxStaticText(this,-1,_T("Min"));
                    sizer2->Add(label,1,wxALL|wxEXPAND,0);
                    label=new wxStaticText(this,-1,_T("Max"),wxDefaultPosition,wxDefaultSize,wxALIGN_RIGHT);
                    sizer2->Add(label,0,wxALL|wxEXPAND,0);
                rightsizer->Add(sizer2,0,wxALL|wxEXPAND,0);
        mainsizer->Add(rightsizer,0,wxALL|wxEXPAND,0);
    SetSizer(mainsizer);
    int ID_Timer=wxNewId();
    timer=new wxTimer(this,ID_Timer);
    Connect(ID_Timer,wxEVT_TIMER,wxTimerEventHandler(wxFModPlayer::OnTimer));
    // Initialisation des variables
    fm_system=NULL;
    fm_sound=NULL;
    fm_channel=NULL;
    bIsInitialized=false;
    bIsPaused=false;
    bIsPlaying=false;
    bDatasOk=false;
    bIsChangingPos=false;
    currbuff=NULL;
}

wxFModPlayer::~wxFModPlayer()
{
    delete timer;
    if (bIsInitialized) fm_system->release();
}

bool wxFModPlayer::Initialize()
{
    if (bIsInitialized) return false;
    fm_result=FMOD::System_Create(&fm_system);
    if (fm_result!=FMOD_OK)
    {
        wxMessageBox(_T("Impossible de d\351marrer le syst\350me FMod !"),_T("Erreur"),wxICON_ERROR);
        return false;
    }
    fm_result=fm_system->init(10,FMOD_INIT_NORMAL,0);
    if (fm_result!=FMOD_OK)
    {
        wxMessageBox(_T("Impossible d'initialiser le syst\350me FMod !"),_T("Erreur"),wxICON_ERROR);
        fm_system->close();
        return false;
    }
    bIsInitialized=true;
    // Activer le slider du volume
    sldVolume->Enable();

    return true;
}

void wxFModPlayer::EnableButtons(int ButtonsMask)
{
    btnPlay->Enable((ButtonsMask & FMP_BUTTON_PLAY)!=FMP_BUTTON_NONE);
    btnStop->Enable((ButtonsMask & FMP_BUTTON_STOP)!=FMP_BUTTON_NONE);
    btnPrev->Enable((ButtonsMask & FMP_BUTTON_PREV)!=FMP_BUTTON_NONE);
    btnNext->Enable((ButtonsMask & FMP_BUTTON_NEXT)!=FMP_BUTTON_NONE);
}

void wxFModPlayer::OnTimer(wxTimerEvent &event)
{
    if (fm_channel==NULL) return;
    if (bIsChangingPos) return;
    unsigned int ipos=0;
    int m,s,mt,st;
    fm_channel->getPosition(&ipos,FMOD_TIMEUNIT_MS);
    m=ipos/60000;
    s=(ipos%60000)/1000;
    mt=iCurLengthMs/60000;
    st=(iCurLengthMs%60000)/1000;
    sldProgress->SetValue(1000*ipos/iCurLengthMs);
    wxString sInfo;
    sInfo.Printf(_T("Position : %02d:%02d / %02d:%02d"),m,s,mt,st);
    sttPlayInfo->SetLabel(sInfo);
    if (ipos==iCurLengthMs) // Si on est arrivé à la fin du morceau en cours
    {
        timer->Stop();
        fm_channel->stop();
        bIsPaused=false;
        wxCommandEvent evt(wxEVT_FMP_FINISHED,GetId());
        evt.SetEventObject(this);
        GetEventHandler()->AddPendingEvent(evt);
    }
}

void wxFModPlayer::OnBtnPlayClicked(wxCommandEvent &event)
{
    if (bIsPaused)
    {
        // Remettre en route le player
        StartPlaying(false);
    } else {
        if (bIsPlaying)
        {
            // Mettre le player en pause
            btnPlay->SetBitmapLabel(play_e_xpm);
            btnPlay->SetBitmapDisabled(play_d_xpm);
            btnPlay->SetBitmapHover(play_h_xpm);
            btnPlay->SetToolTip(_T("Remettre en route le player depuis la position courante"));
            bIsPaused=true;
            fm_channel->setPaused(true);
            timer->Stop();
        } else {
            StartPlaying();
        }
    }
}

void wxFModPlayer::OnBtnStopClicked(wxCommandEvent &event)
{
    StopPlaying();
}

void wxFModPlayer::OnBtnNextClicked(wxCommandEvent &event)
{
    wxCommandEvent evt(wxEVT_FMP_NEXTFILE,GetId());
    evt.SetEventObject(this);
    GetEventHandler()->ProcessEvent(evt);
}

void wxFModPlayer::OnBtnPrevClicked(wxCommandEvent &event)
{
    wxCommandEvent evt(wxEVT_FMP_PREVFILE,GetId());
    evt.SetEventObject(this);
    GetEventHandler()->ProcessEvent(evt);
}

void wxFModPlayer::OnChangePosition(wxScrollEvent &event)
{
    if (fm_channel==NULL) return;
    bIsChangingPos=true;

    static wxString sInfo;

    unsigned int ipos=event.GetPosition()*iCurLengthMs/1000;

    int m,s,mt,st;

    m=ipos/60000;
    s=(ipos%60000)/1000;
    mt=iCurLengthMs/60000;
    st=(iCurLengthMs%60000)/1000;
    sInfo.Printf(_T("Position : %02d:%02d / %02d:%02d"),m,s,mt,st);
    sttPlayInfo->SetLabel(sInfo);
    if (wxGetMouseState().LeftDown()) return;
    bIsChangingPos=false;
    fm_channel->setPosition(ipos,FMOD_TIMEUNIT_MS);
}

void wxFModPlayer::OnChangeVolume(wxScrollEvent &event)
{
    if (fm_channel==NULL) return;
    float volume=(float)sldVolume->GetValue()/255;
    fm_channel->setVolume(volume);
}

bool wxFModPlayer::SetStreamDatas(void *datas, size_t length, const wxString &DispName)
{
    if ((currbuff!=NULL)&&(currbuff==(char*)datas)) return true;
    if (fm_sound!=NULL)
    {
        if (fm_sound->release()!=FMOD_OK) return false;
        timer->Stop();
        fm_channel=NULL;
        fm_sound=NULL;
    }
    if (datas==NULL) // Remise à zéro du player
    {
        sttStrmInfo->SetLabel(_T("- - -"));
        sttPlayInfo->SetLabel(_T("Position : 00:00 / 00:00"));
        currbuff=NULL;
        bIsPaused=false;
        bIsPlaying=false;
        bDatasOk=false;
        return true;
    }
    FMOD_CREATESOUNDEXINFO csxi;
    memset(&csxi,0,sizeof(FMOD_CREATESOUNDEXINFO));
    csxi.cbsize=sizeof(csxi);
    csxi.length=(unsigned int)length;
    currbuff=(char*)datas;
    if (fm_system->createSound(currbuff,FMOD_CREATESTREAM|FMOD_OPENMEMORY,&csxi,&fm_sound)!=FMOD_OK)
    {
        return false;
    }
    sttStrmInfo->SetLabel(DispName);
    sldProgress->SetValue(0);
    int m,s;
    fm_sound->getLength(&iCurLengthMs,FMOD_TIMEUNIT_MS);
    m=iCurLengthMs/60000;
    s=(iCurLengthMs%60000)/1000;
    sttPlayInfo->SetLabel(wxString::Format(_T("Position : 00:00 / %02d:%02d"),m,s));
    //sldProgress->Enable();
    sldProgress->SetValue(0);
    bIsPaused=false;
    bIsPlaying=false;
    bDatasOk=true;
    return true;
}

bool wxFModPlayer::StartPlaying(bool restart)
{
    if ((!bDatasOk)||(fm_sound==NULL)) return false;
    if (!bIsPaused)
    {
        fm_system->playSound(FMOD_CHANNEL_FREE,fm_sound,true,&fm_channel);
        bIsPaused=true;
    }
    sldProgress->Enable();
    float volume=(float)sldVolume->GetValue()/255;
    fm_channel->setVolume(volume);
    if (restart==false)
    {
        unsigned int ipos=sldProgress->GetValue()*iCurLengthMs/1000;
        fm_channel->setPosition(ipos,FMOD_TIMEUNIT_MS);
    } else {
        sldProgress->SetValue(0);
        fm_channel->setPosition(0,FMOD_TIMEUNIT_MS);
    }
    fm_channel->setPaused(false);
    bIsPlaying=true;
    bIsPaused=false;
    timer->Start(TIMER_INTEVALL,false);
    btnPlay->SetBitmapLabel(pause_e_xpm);
    btnPlay->SetBitmapDisabled(pause_d_xpm);
    btnPlay->SetBitmapHover(pause_h_xpm);
    btnPlay->SetToolTip(_T("Mettre le player en pause"));
    btnPlay->Enable();
    btnStop->Enable();
    return true;
}

void wxFModPlayer::StopPlaying()
{
    if ((!bDatasOk)||(fm_sound==NULL)) return;
    if (fm_channel==NULL) return;
    timer->Stop();
    fm_channel->setPaused(true);
    sldProgress->SetValue(0);
    sldProgress->Disable();
    fm_channel->stop();
    bIsPlaying=false;
    bIsPaused=false;
    btnPlay->SetBitmapLabel(play_e_xpm);
    btnPlay->SetBitmapDisabled(play_d_xpm);
    btnPlay->SetBitmapHover(play_h_xpm);
    btnPlay->Enable();
    btnStop->Disable();
    btnPlay->SetToolTip(_T("Mettre en route le lecteur depuis le d\351but du morceau"));
    int m=iCurLengthMs/60000;
    int s=(iCurLengthMs%60000)/1000;
    sttPlayInfo->SetLabel(wxString::Format(_T("Position : 00:00 / %02d:%02d"),m,s));
}

bool wxFModPlayer::IsPlaying()
{
    return bIsPlaying;
}

bool wxFModPlayer::IsPaused()
{
    return bIsPaused;
}

void wxFModPlayer::SetDisplayName(const wxString& dispname)
{
    sttStrmInfo->SetLabel(dispname);
}
